-- LBP.lua


		function deepcopy(t)
			if type(t) ~= 'table' then return t end
			local mt = getmetatable(t)
			local res = {}
			for k,v in pairs(t) do
				if type(v) == 'table' then
					v = deepcopy(v)
				end
				res[k] = v
			end
			setmetatable(res,mt)
			return res
		end

-- Variablen
local NameOfProject = "Lazy Boss Preparation"										-- Name des Projekts
local EventFrame														-- Frame, das auf Events reagiert
local TimeSinceLastUpdate = 0.0
local UpdateFrequency = 1;
local LBPMainframe 												-- dummy fuer das Hauptframe
local LBPConfigframe 
local showmode = false;

LBP = {}


LBP_DB = {															-- default Konfiguration,
																		-- wird whrend des Variabelnladens
																		-- ueberschrieben

};


local debugging = false


function LBP.echo( self, msg )												-- Beginn echo
																		-- Einfache Routine zur Ausgabe von Nachrichten
	if not msg then
		msg = "Error: nil"
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00FFFF"..NameOfProject..":|r "..msg)

end	

																-- Ende echo

																
																
function LBP.help( self )															-- Beginn help
	LBP.echo("LBP Hilfe")

end	

function LBP.CreateConfig(self)
	
	
	local frame = LBP:CreateFrame("frame", "LBPConfigFrame", UIParent, nil, "CENTER", UIParent, "CENTER", -300, 0, 300, 500)
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	--frame:Show()
	--tinsert(UISpecialFrames,"LBPConfigFrame");

	
	local editcard = LBP:CreateFrame("frame", "editcard", frame, nil, "TOP", frame, "TOP", 0, -10, 1, 1)
	
	local editzone
	local editsubzone
	local editid
	
	function frame.SetTemplate(self, zone, subzone, id)
		editzone = zone;
		editsubzone = subzone;
		editid = id;
	end

		
	frame.button = CreateFrame("BUTTON", "Button_CloseConfig", frame, "UIPanelButtonTemplate")
		frame.button:SetText("X")
		frame.button:SetWidth(30)
		frame.button:SetHeight(30)
		frame.button:SetScript("OnClick", 
			function(self) 
						LBPMainFrame.zone = nil
		LBPMainFrame.subzone = nil
				showmode = false;
				frame:Hide()
				LBPMainframe:Show()
			end)
		frame.button:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, 0)


	frame.button = CreateFrame("BUTTON", "Button_CreateCard", frame, "UIPanelButtonTemplate")
		frame.button:SetText("Create Card")
		frame.button:SetWidth(80)
		frame.button:SetHeight(30)
		frame.button:SetScript("OnClick", 
			function(self) 
	
	local zonetext = GetZoneText()
	local subzonetext = GetSubZoneText()
	
	if not InCombatLockdown() and subzonetext ~= "" then
		LBPMainFrame.zone = nil
		LBPMainFrame.subzone = nil
		local specid, specname, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
		card = {};
		card["Name"] = subzonetext;
		
		card["Talents"] = LBP:GetTalentString();
		card["Spec"] = specname;
		card["Glyphs"] = {
			["1"] = {},
			["2"] = {}
		};
		for index,value in pairs(LBP:GetGlyphTable()) do
			card["Glyphs"][tostring(value[1])][value[2]] = value[3];
		end
		card["Macro1"] = "/script print(\"LBP Macro #1\")";
		card["Macro2"] = "/script print(\"LBP Macro #2\")";
		card["Macro3"] = "/script print(\"LBP Macro #3\")";
		card["Macro4"] = "/script print(\"LBP Macro #4\")";
		
		if not LBP_DB[zonetext] then LBP_DB[zonetext] = {} end
		if not LBP_DB[zonetext][subzonetext] then LBP_DB[zonetext][subzonetext] = {} end
		
		local id = time()
		
		LBP_DB[zonetext][subzonetext][id] = card;
	
		editzone = zonetext;
		editsubzone = subzonetext;
		editid = id;

	end	
	
	
	frame:Build()	
			end)
		frame.button:SetPoint("TOP", frame, "TOP", 0, 0)
		

		
	local textbox = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", frame, "TOP", 0, -10, 280, 30, "LEFT", "TOP", 1, 1, 1, 1)
	
	
	textbox:SetText("Config")
	

	local list = LBP:CreateFrame("frame", "Liste", frame, nil, "TOP", textbox, "BOTTOM", 0, 0, 1, 1)

	
	

	
	
	
	
	local list_anker = LBP:CreateFrame("ScrollFrame", "List_Scroll", frame, "UIPanelScrollFrameTemplate", "TOPLEFT", frame, "TOPLEFT", 10, -30, 280, 160)

	
	
	frame.button_togglezones = CreateFrame("BUTTON", "Button_togglezones", frame, "UIPanelButtonTemplate")
		frame.button_togglezones:SetWidth(120)
		frame.button_togglezones:SetHeight(20)
		
		frame.button_togglezones:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 10, 10)
		
	frame.showzones = false;


	local glyphlist_rahmen = LBP:CreateFrame("frame", "glyphlist_rahmen", frame, nil, "TOPLEFT", frame, "TOPRIGHT", 0, 0, 200, 300)
		glyphlist_rahmen:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
		tinsert(UISpecialFrames,"glyphlist_rahmen");
	local glyphlist_anker = LBP:CreateFrame("ScrollFrame", "Glyphlist_Scroll", glyphlist_rahmen, "UIPanelScrollFrameTemplate", "TOPLEFT", glyphlist_rahmen, "TOPLEFT", 10, -10, 200-20-20, 280)

	local glyphlist = LBP:CreateFrame("frame", "LBPGlyphlist", glyphlist_anker, nil, "TOPLEFT", glyphlist_anker, "TOPLEFT", 0, 0, 1, 1)
	
		glyphlist.list = {}
		local n = 3;
		
		local tmpframe = LBP:CreateFrame("frame", "LBPGlyphlist", glyphlist, nil, "TOPLEFT", glyphlist, "TOPLEFT", 0, 0, 200, 32)
				tmpframe.icon = LBP:CreateFrame("frame", "LBPGlyphlist", tmpframe, nil, "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 32, 32)
				tmpframe.icon:SetBackdrop({bgFile =  "Interface/ICONS/INV_MISC_QUESTIONMARK"});
				tmpframe.tb_name =  LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", tmpframe.icon, "TOPRIGHT", 10, 0, 100, 20, "LEFT", "TOP", 1, 1, 1, 1)
				tmpframe.tb_name:SetText("egal")
				tmpframe.type = 1;
				tmpframe:Hide()
				
				glyphlist.list[1] = tmpframe;
				
		local tmpframe = LBP:CreateFrame("frame", "LBPGlyphlist", glyphlist, nil, "TOPLEFT", glyphlist, "TOPLEFT", 0, 0, 200, 32)
				tmpframe.icon = LBP:CreateFrame("frame", "LBPGlyphlist", tmpframe, nil, "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 32, 32)
				tmpframe.icon:SetBackdrop({bgFile =  "Interface/ICONS/INV_MISC_QUESTIONMARK"});
				tmpframe.tb_name =  LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", tmpframe.icon, "TOPRIGHT", 10, 0, 100, 20, "LEFT", "TOP", 1, 1, 1, 1)
				tmpframe.tb_name:SetText("egal")
				tmpframe.type = 2;
				tmpframe:Hide()
				
				glyphlist.list[2] = tmpframe;
		
		
		for a=1,GetNumGlyphs() do 
			local name, glyphType, isKnown, icon, castSpell,link, subText = GetGlyphInfo(a)
			
			if icon then 
			
				local tmpframe = LBP:CreateFrame("frame", "LBPGlyphlist", glyphlist, nil, "TOPLEFT", glyphlist, "TOPLEFT", 0, 0, 200, 32)
				tmpframe.icon = LBP:CreateFrame("frame", "LBPGlyphlist", tmpframe, nil, "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 32, 32)
				tmpframe.icon:SetBackdrop({bgFile = icon});
				tmpframe.tb_name =  LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", tmpframe.icon, "TOPRIGHT", 10, 0, 100, 20, "LEFT", "TOP", 1, 1, 1, 1)
				tmpframe.tb_name:SetText(name)
				
				tmpframe.type = glyphType;
				tmpframe.id = castSpell;
				tmpframe:Hide()
				
				glyphlist.list[n] = tmpframe;
			n=n+1; 	
			end 
			
		end


	glyphlist:SetSize(250,32)
	glyphlist_anker:SetScrollChild(glyphlist)

	
	function glyphlist_rahmen:Build(icon, glyph_type)
		local n = 0;
		for index, value in pairs(glyphlist.list) do
			value:Hide()

			if value.icon:GetBackdrop().bgFile ~= icon then

				if value.type == glyph_type then
				value:Show()
				value:ClearAllPoints()
				value:SetPoint("TOPLEFT", glyphlist, "TOPLEFT", 0,-n*32)
				
				value:SetScript("OnMouseUp", 
					function(self) 
						LBP_DB[editzone][editsubzone][editid]["Glyphs"][tostring(glyph_type)][icon] = nil;
						LBP_DB[editzone][editsubzone][editid]["Glyphs"][tostring(glyph_type)][value.icon:GetBackdrop().bgFile] = value.id;
						glyphlist_rahmen:Hide()
						frame:Build()
					end
				)
				
				--LBP[editzone][editsubzone][editid]["Glyphs"][
				
				n=n+1;
				end
			end
			
		end
--		glyphlist:SetSize(250,32)
		--glyphlist_anker:SetScrollChild(glyphlist)
	--print(name)
--		print(glyph_type)
	end
	
	function glyphlist_rahmen:Toggle()
		if glyphlist_rahmen:IsVisible() then
			glyphlist_rahmen:Hide()
		else
			glyphlist_rahmen:Show()
		end
	end
	
	glyphlist_rahmen:SetFrameStrata("TOOLTIP")
	glyphlist_rahmen:Hide()
	
	
	











	
			
			
--	local card = deepcopy(LBP_DB[zone][subzone][id]);

	local editcard = LBP:CreateFrame("frame", "LBPMainFrame", frame, nil, "TOPLEFT", frame, "TOPRIGHT", 0, 0, 600, 500)
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	editcard:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	editcard:SetBackdropColor(0, 0, 0 , 1)
	
	--frame:Show()
	editcard.tb_name = LBP:CreateFontString(editcard, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", editcard, "TOPLEFT", 10, -15, 50, 20, "LEFT", "TOP", 1, 1, 1, 1)
		editcard.tb_name:SetText("Name:")

	editcard.editname = LBP:CreateFrame("EditBox", "editcard_editname", editcard, "InputBoxTemplate", "LEFT", editcard.tb_name, "RIGHT", 20,0, 200, 50)
		editcard.editname:SetAutoFocus(false) 
		editcard.editname:SetJustifyH("LEFT");
		
			

	editcard.tb_zone = LBP:CreateFontString(editcard, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", editcard.tb_name, "BOTTOMLEFT", 0, -15, 300, 20, "LEFT", "TOP", 1, 1, 1, 1)

	editcard.tb_subzone = LBP:CreateFontString(editcard, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", editcard.tb_zone, "BOTTOMLEFT", 0, -5, 300, 20, "LEFT", "TOP", 1, 1, 1, 1)
	
	editcard.tb_spec = LBP:CreateFontString(editcard, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", editcard.tb_subzone, "BOTTOMLEFT", 0, -5, 300, 20, "LEFT", "TOP", 1, 1, 1, 1)
	
	
	
	editcard.Talents = {};
	
	for a=1,3*6 do
		local _, iconTexture = GetTalentInfo(a)
		
		local tmpframe = LBP:CreateFrame("frame", "LBPTalent"..a, editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", mod(a-1,3)*32-120, -ceil(a/3)*32,  32, 32)
		
		tmpframe.texture = tmpframe:CreateTexture("LBPTalent"..a)
			tmpframe.texture:SetTexture(iconTexture)
			tmpframe.texture:SetAllPoints()

		editcard.Talents[a] = tmpframe;
		editcard.Talents[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.Talents[a]); GameTooltip:SetTalent(a); GameTooltip:Show(); end)
		editcard.Talents[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
	end

	editcard.Glyph = {};
	
	for a=1,6 do
	--local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, frame, nil, "LEFT", frame, "RIGHT", -64+floor((a-1)/2)*64, -64*mod(a,2), 64-16*mod(a,2), 64-16*mod(a,2))
	local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", mod(a,2)*50+50, -math.floor((a-1)/2)*50-50, 48-12*mod(a,2), 48-12*mod(a,2))
	
	
		function tmpframe:SetGlyph(tmp, tmp2)
			tmpframe:SetBackdrop({
				bgFile = tmp,
				tile = false, tileSize = height, edgeSize = 0,
				insets = { left = 0, right = 0, top = 0, bottom = 0 }
			})
			if tmp2 then
				tmpframe:SetBackdropColor(1,1,1,1);
			else
				tmpframe:SetBackdropColor(1,0.2,0.2,1);
			end
		end
	editcard.Glyph[a] = tmpframe;
	end

		editcard.button2 = CreateFrame("BUTTON", "SetThisNTC", editcard, "UIPanelButtonTemplate")
		editcard.button2:SetText("Change T/G/S to actual T/G/S")
		editcard.button2:SetWidth(180)
		editcard.button2:SetHeight(30)
		editcard.button2:SetScript("OnClick", 
			function(self) 
				local specid, specname, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
				if not LBP_DB[editzone] then LBP_DB[editzone] = {}; end -- that should not happen
				if not LBP_DB[editzone][editsubzone] then LBP_DB[editzone][editsubzone] = {}; end -- that should not happen
				--LBP_DB[zone][subzone][id] = {};
				LBP_DB[editzone][editsubzone][editid]["Talents"] = LBP:GetTalentString();
				LBP_DB[editzone][editsubzone][editid]["Spec"] = specname;
				LBP_DB[editzone][editsubzone][editid]["Glyphs"] = {["1"] = {}, ["2"] = {}, };
				for index,value in pairs(LBP:GetGlyphTable()) do
					LBP_DB[editzone][editsubzone][editid]["Glyphs"][tostring(value[1])][value[2]] = value[3];
				end
				frame:Build()
			end)
		editcard.button2:SetPoint('TOP', editcard.tb_spec, 'BOTTOM', 0, -300)
		
	editcard.button3 = CreateFrame("BUTTON", "RemoveNTC", editcard, "UIPanelButtonTemplate")
		editcard.button3:SetText("Remove this card")
		editcard.button3:SetWidth(180)
		editcard.button3:SetHeight(30)
		editcard.button3:SetScript("OnClick", 
			function(self) 
				LBP_DB[editzone][editsubzone][editid] = nil;
				local n = 0;
				for index in pairs(LBP_DB[editzone][editsubzone]) do
					n=n+1;
				end
				if n == 0 then LBP_DB[editzone][editsubzone] = nil; end
				
				n = 0;
				for index in pairs(LBP_DB[editzone]) do
					n=n+1;
				end
				if n == 0 then LBP_DB[editzone] = nil; end
				
				editzone = nil;
				editsubzone = nil;
				editid = nil;
				frame:Build()	
			end)
		editcard.button3:SetPoint('TOP', editcard.button2, 'BOTTOM', 0, -8)


		
		
	editcard.button4 = CreateFrame("BUTTON", "CopyNTC", editcard, "UIPanelButtonTemplate")
		editcard.button4:SetText("Copy this Template to this zone")
		editcard.button4:SetWidth(180)
		editcard.button4:SetHeight(30)
		editcard.button4:SetScript("OnClick", 
			function(self) 
				if not LBP_DB[GetZoneText()] then LBP_DB[GetZoneText()] = {}; end
				if not LBP_DB[GetZoneText()][GetSubZoneText()] then LBP_DB[GetZoneText()][GetSubZoneText()] = {}; end
				newid = time()
				LBP_DB[GetZoneText()][GetSubZoneText()][newid] = deepcopy(LBP_DB[editzone][editsubzone][editid]);
				editzone = GetZoneText()
				editsubzone = GetSubZoneText()
				editid = newid
				
				frame:Build()
			end)
		editcard.button4:SetPoint('TOP', editcard.tb_spec, 'BOTTOM', 300, -300)


	
	
	editcard.macroframe1 = LBP:CreateFrame("frame", "Macroframe1", editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", -24-4-48-8, -250, 48, 48);
	editcard.macroframe2 = LBP:CreateFrame("frame", "Macroframe2", editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", -24-4, -250, 48, 48);
	editcard.macroframe3 = LBP:CreateFrame("frame", "Macroframe3", editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", 24+4, -250, 48, 48);
	editcard.macroframe4 = LBP:CreateFrame("frame", "Macroframe4", editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", 24+4+48+8, -250, 48, 48);


	
	
	function CreateMacroEditBox(self, name, parent, width, height)
	
	
	local scrollframe = LBP:CreateFrame("ScrollFrame", "ScrollFrame_"..name, parent, "UIPanelScrollFrameTemplate", "TOPLEFT", parent, "TOPLEFT", 0, 0, width, height)
		scrollframe.name = "Scrollframe";
			
	local scrollchild = CreateFrame("EditBox", "LBPEditBox_"..name, scrollframe) --, "InputBoxTemplate")
		scrollchild:SetPoint("TOPLEFT", scrollframe, "TOPLEFT", 8,-6)
		scrollchild:SetPoint("BOTTOMRIGHT", scrollframe, "BOTTOMRIGHT", -8,6)
		
		scrollchild:SetScript("OnEscapePressed", function(self) EditBox_ClearFocus(self) end)
		scrollchild:SetScript("OnEditFocusLost", function(self) EditBox_ClearHighlight(self); end)
		scrollchild:SetScript("OnEditFocusGained", function(self) EditBox_HighlightText(self); end)
		scrollchild:SetFont("Fonts\\ARIALN.TTF",14,"none")
		scrollchild:SetMultiLine(true)
		scrollchild:SetAutoFocus(false) 
		scrollchild:SetMaxLetters(255);
		scrollchild:SetCursorPosition(0)
		scrollchild:SetScript("OnCursorChanged", 
			function(self, x, y, width, height) 
				local d = -y-scrollframe:GetVerticalScroll()
				if d>13.9*4 or d<0 then 
					scrollframe:SetVerticalScroll(math.max(scrollframe:GetVerticalScroll()+13.99*d/abs(d),0)) 
					scrollframe:UpdateScrollChildRect()
				end 
			end
		)

		scrollframe:SetSize(width, height)--80-8-8)
		scrollchild:SetSize(width, height)
		scrollframe:SetScrollChild(scrollchild)
		
		--scrollframe:Hide()
		
		return scrollframe, scrollchild
	end
	
	
	
	editcard.tb_macro1 = LBP:CreateFontString(editcard, "tb_Macro1", "ARTWORK", "GameFontNormal", "TOPLEFT", editcard, "TOP", 10, -10, 200, 20, "LEFT", "TOP", 1, 1, 1, 1)
		editcard.tb_macro1:SetText("Macro 1")

		
		
	editcard.button_m1 = CreateFrame("BUTTON", "CopyNTC", editcard, "UIPanelButtonTemplate")
		editcard.button_m1:SetText("Reset")
		editcard.button_m1:SetWidth(50)
		editcard.button_m1:SetHeight(30)
		editcard.button_m1:SetPoint("LEFT", editcard.tb_macro1, "RIGHT", 0, 0)		
		
		
		
	editcard.rahmen_macro1 = LBP:CreateFrame("frame", "Rahmen Macro1", editcard, nil, "TOPLEFT", editcard.tb_macro1, "BOTTOMLEFT", 0, 0, 280, 80)
		editcard.rahmen_macro1:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });

	editcard.editbox_macro1, editcard.editbox_macro1_editbox = CreateMacroEditBox(self, "macro1", editcard.rahmen_macro1, 280-30-8, 80-8-8)
		editcard.editbox_macro1:SetPoint("TOPLEFT", editcard.rahmen_macro1, "TOPLEFT", 10,-8)



	editcard.tb_macro2 = LBP:CreateFontString(editcard, "tb_Macro2", "ARTWORK", "GameFontNormal", "TOPLEFT", editcard, "TOP", 10, -110, 200, 20, "LEFT", "TOP", 1, 1, 1, 1)
		editcard.tb_macro2:SetText("Macro 2")
		
	editcard.button_m2 = CreateFrame("BUTTON", "CopyNTC", editcard, "UIPanelButtonTemplate")
		editcard.button_m2:SetText("Reset")
		editcard.button_m2:SetWidth(50)
		editcard.button_m2:SetHeight(30)
		editcard.button_m2:SetPoint("LEFT", editcard.tb_macro2, "RIGHT", 0, 0)

	editcard.rahmen_macro2 = LBP:CreateFrame("frame", "Rahmen Macro2", editcard, nil, "TOPLEFT", editcard.tb_macro2, "BOTTOMLEFT", 0, 0, 280, 80)
		editcard.rahmen_macro2:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });

	editcard.editbox_macro2, editcard.editbox_macro2_editbox = CreateMacroEditBox(self, "macro2", editcard.rahmen_macro2, 280-30-8, 80-8-8)
		editcard.editbox_macro2:SetPoint("TOPLEFT", editcard.rahmen_macro2, "TOPLEFT", 10,-8)

	
		
			
			
			
	
	
function frame:Build()
	if frame.showzones then
		frame.button_togglezones:SetText("Hide Subzones")
		frame.button_togglezones:SetScript("OnClick", function(self) frame.showzones = false; frame:Build(nil) end)
	else
		frame.button_togglezones:SetText("Show Subzones")
		frame.button_togglezones:SetScript("OnClick", function(self) frame.showzones = true; frame:Build(nil) end)
	end

	list:Hide()
	list = nil;
	list = LBP:CreateFrame("frame", "Liste", list_anker, nil, "TOPLEFT", list_anker, "TOPLEFT", 0, 0, 1, 1)
	
	local textbox = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormalLarge", "TOPLEFT", list, "TOPLEFT", 0, 0, 280, 1, "LEFT", "TOP", 1, 1, 1, 1)
	
	list:SetHeight(list:GetHeight()+textbox:GetHeight())
		
	for zone,value in pairs(LBP_DB) do
		textbox = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormal", "TOP", textbox, "BOTTOM", 0, 0, 280, 20, "LEFT", "TOP", 1, 1, 1, 1)
		textbox:SetText("|c00aaaaaa"..zone.."|r")
		
		list:SetHeight(list:GetHeight()+textbox:GetHeight())
		
		for subzone,value in pairs(LBP_DB[zone]) do
		
			if frame.showzones then
				textbox = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormal", "TOP", textbox, "BOTTOM", 0, 0, 280, 20, "LEFT", "TOP", 1, 1, 1, 1)
				textbox:SetText("|c00aaaaaa  " .. subzone.."|r")
				
				list:SetHeight(list:GetHeight()+textbox:GetHeight())
			end
			
			
			
			
			for id, listcard in pairs(LBP_DB[zone][subzone]) do

				textbox = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", textbox, "BOTTOM", 0, 0, 280, 30, "LEFT", "TOP", 1, 1, 1, 1)
			
				if id == editid then
					textbox:SetText("|c00ffffff >  " .. listcard["Name"].."|r")
				else
					textbox:SetText("|c00ffffff    " .. listcard["Name"].."|r")
				end
				list:SetHeight(list:GetHeight()+textbox:GetHeight())


--			frame:SetText(frame:GetText() .. "|c00aaaaaa  " .. value["Name"].."|r\n")
				--frame:SetText(frame:GetText() .. "|c00aaaaaa    " .. index.."|r\n")
				
				
				
	list.button = CreateFrame("BUTTON", "Test", list, nil)
		list.button:SetText("Test")
		list.button:SetWidth(280)
		list.button:SetHeight(30)
		list.button:SetPoint('TOP', textbox, 'TOP', 0, 0)
		list.button:SetScript("OnClick", 
			function(self) 
				editzone = zone;
				editsubzone = subzone;
				editid = id;
			
				frame:Build()
			end)
			
			end
			end
	end
	
	list_anker:SetSize(260, 430)
	--list:SetHeight(500)
	
	list_anker:SetScrollChild(list)
	
	
	
	if editid then
		local card = deepcopy(LBP_DB[editzone][editsubzone][editid]);
		local specid, spec, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
	
		editcard.editname:SetText(LBP_DB[editzone][editsubzone][editid]["Name"])
		editcard.editname:SetScript("OnTextChanged",
			function (self)
				LBP_DB[editzone][editsubzone][editid]["Name"] = editcard.editname:GetText()
				frame:Build()
			end)
			
			
		editcard.tb_zone:SetText(editzone)

		editcard.tb_subzone:SetText(editsubzone)
		
		if card["Spec"] == spec then
			editcard.tb_spec:SetText("Spec: " .."|cff00FF00"..card["Spec"].."|r".."");
		else
			editcard.tb_spec:SetText("Spec: " .."|cffFF0000"..card["Spec"].."|r".."");
		end

		-- Talents
		for a = 1,6 do
			for b = 0,2 do
				s = tonumber(string.sub(card["Talents"],a,a));
						
			    if b==s then
					editcard.Talents[(a-1)*3+b+1].texture:SetDesaturated(0);
					editcard.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,1,1,1);
					editcard.Talents[(a-1)*3+b+1]:SetHeight(32)
					editcard.Talents[(a-1)*3+b+1]:SetWidth(32)
					
					editcard.Talents[(a-1)*3+b+1]:SetScript("OnMouseUp", function() LBP_DB[editzone][editsubzone][editid]["Talents"] = string.sub(card["Talents"],1,a-1).."3"..string.sub(card["Talents"],a+1,6); frame:Build() end)
				else
					editcard.Talents[(a-1)*3+b+1].texture:SetDesaturated(1);
					editcard.Talents[(a-1)*3+b+1]:SetHeight(24)
					editcard.Talents[(a-1)*3+b+1]:SetWidth(24)
				
					editcard.Talents[(a-1)*3+b+1]:SetScript("OnMouseUp", function() LBP_DB[editzone][editsubzone][editid]["Talents"] = string.sub(card["Talents"],1,a-1)..b..string.sub(card["Talents"],a+1,6); frame:Build() end)
				end
			end
		end
		
		
		-- Glpyhs
		
		local glyphtable = LBP:GetGlyphTable(); -- get the current glphs
		local copy = deepcopy(card["Glyphs"])
		
		
		for slot, value in pairs(glyphtable) do
			local glyphtype = value[1]
			editcard.Glyph[slot]:SetGlyph("Interface/ICONS/INV_MISC_QUESTIONMARK", true)
				editcard.Glyph[slot]:SetScript("OnMouseUp", function(self) 
					local point, relativeTo, relativePoint, xOffset, yOffset = glyphlist_rahmen:GetPoint(1)
				
					glyphlist_rahmen:Build("Interface/ICONS/INV_MISC_QUESTIONMARK", value[1])
					glyphlist_rahmen:ClearAllPoints()
					glyphlist_rahmen:SetPoint("LEFT", editcard.Glyph[slot], "RIGHT")
				
					if relativeTo == editcard.Glyph[slot] then
						glyphlist_rahmen:Toggle()
					else
						glyphlist_rahmen:Show()
					end
				end)
			
			for icon, glyphid in pairs(copy[tostring(glyphtype)]) do
				editcard.Glyph[slot]:SetGlyph(icon, true)
				editcard.Glyph[slot]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.Glyph[slot]); GameTooltip:SetGlyphByID(glyphid); GameTooltip:Show(); end)
				editcard.Glyph[slot]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				
				editcard.Glyph[slot]:SetScript("OnMouseUp", function(self) 
					local point, relativeTo, relativePoint, xOffset, yOffset = glyphlist_rahmen:GetPoint(1)
				
					glyphlist_rahmen:Build(icon, value[1])
					glyphlist_rahmen:ClearAllPoints()
					glyphlist_rahmen:SetPoint("LEFT", editcard.Glyph[slot], "RIGHT")
				
					if relativeTo == editcard.Glyph[slot] then
						glyphlist_rahmen:Toggle()
					else
						glyphlist_rahmen:Show()
					end
				end)
				
				copy[tostring(glyphtype)][icon] = nil;
				break
			end
		end
		
		
--[[
		for slot,value in pairs(glyphtable) do
			editcard.Glyph[slot]:SetGlyph("Interface/ICONS/INV_MISC_QUESTIONMARK", true)
			
			local glyphtype = value[1];
			local icon = value[2];
			
			
			for index, glyphid in pairs(copy[tostring(glyphtype)]) do
	
				if icon == index then
					editcard.Glyph[slot]:SetGlyph(icon, true)
					editcard.Glyph[slot]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.Glyph[slot]); GameTooltip:SetGlyphByID(glyphid); GameTooltip:Show(); end)
					editcard.Glyph[slot]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
					glyphtable[slot] = nil;
					copy[tostring(glyphtype)][index] = nil;
				end
			end		
			editcard.Glyph[slot]:SetScript("OnMouseUp", function(self) 
				local point, relativeTo, relativePoint, xOffset, yOffset = glyphlist_rahmen:GetPoint(1)
				
				glyphlist_rahmen:Build(icon, value[1])
				glyphlist_rahmen:ClearAllPoints()
				glyphlist_rahmen:SetPoint("LEFT", editcard.Glyph[slot], "RIGHT")
				
				if relativeTo == editcard.Glyph[slot] then
					glyphlist_rahmen:Toggle()
				else
					glyphlist_rahmen:Show()
				end
			end)
		end
		
		for slot, value in pairs(glyphtable) do
			local glyphtype = value[1]
			for icon, glyphid in pairs(copy[tostring(glyphtype)]) do
				editcard.Glyph[slot]:SetGlyph(icon, false)
				editcard.Glyph[slot]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.Glyph[slot]); GameTooltip:SetGlyphByID(glyphid); GameTooltip:Show(); end)
				editcard.Glyph[slot]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				copy[tostring(glyphtype)][icon] = nil;
				break
			end
		end
--]]		
		

		-- Macros
		if not card["Macro1"] then card["Macro1"] = "/script print(\"LBP: Macro #1\")"; end
		if not card["Macro2"] then card["Macro2"] = "/script print(\"LBP: Macro #2\")"; end
		if not card["Macro3"] then card["Macro3"] = "/script print(\"LBP: Macro #3\")"; end
		if not card["Macro4"] then card["Macro4"] = "/script print(\"LBP: Macro #4\")"; end
	
		local name, iconTexture, body = GetMacroInfo("LBP Macro 3");
			editcard.macroframe3:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			editcard.macroframe3:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.macroframe3); GameTooltip:SetText(card["Macro3"]); GameTooltip:Show(); end)
			editcard.macroframe3:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)

		local name, iconTexture, body = GetMacroInfo("LBP Macro 4");
			editcard.macroframe4:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			editcard.macroframe4:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.macroframe4); GameTooltip:SetText(card["Macro4"]); GameTooltip:Show(); end)
			editcard.macroframe4:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)		
		
		
		

		editcard.editbox_macro1_editbox:SetScript("OnTextChanged", function (self) end )		
		editcard.editbox_macro1_editbox:SetText(LBP_DB[editzone][editsubzone][editid]["Macro1"])
		editcard.editbox_macro1_editbox:SetScript("OnTextChanged",
			function (self)
				LBP_DB[editzone][editsubzone][editid]["Macro1"] = editcard.editbox_macro1_editbox:GetText() EditMacro(GetMacroIndexByName("LBP Macro 1"),"LBP Macro 1",nil, editcard.editbox_macro1_editbox:GetText())
				
				local name, iconTexture, body = GetMacroInfo("LBP Macro 1");
				editcard.macroframe1:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
				editcard.macroframe1:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.macroframe1); GameTooltip:SetText(card["Macro1"]); GameTooltip:Show(); end)
				editcard.macroframe1:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
			end
		)
		editcard.editbox_macro1:UpdateScrollChildRect()
		editcard.editbox_macro1_editbox:SetCursorPosition(0)
		editcard.editbox_macro1:SetVerticalScroll(0)
		
		
		
		editcard.button_m1.text = LBP_DB[editzone][editsubzone][editid]["Macro1"];
		editcard.button_m1:SetScript("OnClick", 
			function(self) 
				editcard.editbox_macro1_editbox:SetText(editcard.button_m1.text)
			end)
		
		
		
		
		
		
		
		
		editcard.editbox_macro2_editbox:SetScript("OnTextChanged", function (self) end )		
		editcard.editbox_macro2_editbox:SetText(LBP_DB[editzone][editsubzone][editid]["Macro2"])
		editcard.editbox_macro2_editbox:SetScript("OnTextChanged",
			function (self)
				LBP_DB[editzone][editsubzone][editid]["Macro2"] = editcard.editbox_macro2_editbox:GetText() EditMacro(GetMacroIndexByName("LBP Macro 2"),"LBP Macro 2",nil, editcard.editbox_macro2_editbox:GetText())
				
				local name, iconTexture, body = GetMacroInfo("LBP Macro 2");
				editcard.macroframe2:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
				editcard.macroframe2:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.macroframe2); GameTooltip:SetText(card["Macro2"]); GameTooltip:Show(); end)
				editcard.macroframe2:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
			end
		)
		editcard.editbox_macro2:UpdateScrollChildRect()
		editcard.editbox_macro2_editbox:SetCursorPosition(0)
		editcard.editbox_macro2:SetVerticalScroll(0)
		
		
		editcard.button_m2.text = LBP_DB[editzone][editsubzone][editid]["Macro2"];
		editcard.button_m2:SetScript("OnClick", 
			function(self) 
				editcard.editbox_macro2_editbox:SetText(editcard.button_m2.text)
			end)
		--[[
		editcard.editbox_macro3_editbox:SetScript("OnTextChanged", function (self) end )		
		editcard.editbox_macro3_editbox:SetText(LBP_DB[editzone][editsubzone][editid]["Macro3"])
		editcard.editbox_macro3_editbox:SetScript("OnTextChanged",
			function (self)
				LBP_DB[editzone][editsubzone][editid]["Macro3"] = editcard.editbox_macro1_editbox:GetText() EditMacro(GetMacroIndexByName("LBP Macro 3"),"LBP Macro 3",nil, editcard.editbox_macro3_editbox:GetText())
			end
		)
		editcard.editbox_macro3:UpdateScrollChildRect()
		editcard.editbox_macro3_editbox:SetCursorPosition(0)
		editcard.editbox_macro3:SetVerticalScroll(0)
		
		editcard.editbox_macro4_editbox:SetScript("OnTextChanged", function (self) end )		
		editcard.editbox_macro4_editbox:SetText(LBP_DB[editzone][editsubzone][editid]["Macro4"])
		editcard.editbox_macro4_editbox:SetScript("OnTextChanged",
			function (self)
				LBP_DB[editzone][editsubzone][editid]["Macro4"] = editcard.editbox_macro1_editbox:GetText() EditMacro(GetMacroIndexByName("LBP Macro 4"),"LBP Macro 4",nil, editcard.editbox_macro1_editbox:GetText())
			end
		)
		editcard.editbox_macro4:UpdateScrollChildRect()
		editcard.editbox_macro4_editbox:SetCursorPosition(0)
		editcard.editbox_macro4:SetVerticalScroll(0)
		--]]
	end

	
	
	
	
	
	
	if editid then
		editcard:Show()
	else	
		editcard:Hide()
	end
	
	return
			
end

		
			
			

	frame:Build()
	
	frame:Hide()
	
	return frame
end



function LBP.CreateCard( self, parent, zone, subzone, id, n)

	local card = deepcopy(LBP_DB[zone][subzone][id]);
	
	local frame = LBP:CreateFrame("frame", "LBP_Templatecard"..time(), parent, nil, "CENTER", parent, "CENTER", 0, 0, 300, 450)
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	
	
	
	frame:SetScript("OnMouseUp", function() ToggleTalentFrame(); end)
	
	
	--frame:Show()
	local textbox = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", frame, "TOP", 0, -10, 300, 50, "CENTER", "TOP", 1, 1, 1, 1)
	
	frame.timeUpdated = 0;
	
	frame.Talents = {};
	
	for a=1,3*6 do
		local _, iconTexture = GetTalentInfo(a)
		
		local tmpframe = LBP:CreateFrame("frame", "LBPTalent"..a, frame, nil, "CENTER", textbox, "BOTTOM", mod(a-1,3)*32-120, -ceil(a/3)*32,  32, 32)
		
		
		tmpframe.texture = tmpframe:CreateTexture("LBPTalent"..a)
			tmpframe.texture:SetTexture(iconTexture)
			tmpframe.texture:SetAllPoints()
			--texture:SetPoint("TOPLEFT" , tmpframe , "TOPLEFT", mod(a-1,3)*32-120, -ceil(a/3)*32)


		frame.Talents[a] = tmpframe;
		frame.Talents[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Talents[a]); GameTooltip:SetTalent(a); GameTooltip:Show(); end)
		frame.Talents[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
		--frame.Talents[a]:SetScript("OnMouseUp", function() if PlayerTalentFrame and PlayerTalentFrame:IsVisible() then PlayerTalentFrame_Close() else ToggleTalentFrame() PlayerTalentFrame_Open() end end)
		frame.Talents[a]:SetScript("OnMouseUp", function() ToggleTalentFrame() PlayerTalentFrame_Open() end)
	

			--tmpframe:SetBackdrop({
--				bgFile = iconTexture,
				--tile = false, tileSize = height, edgeSize = 0,
				--insets = { left = 0, right = 0, top = 0, bottom = 0 }
			--})
		--frame.Talents[a] = tmpframe;
		

	end

	local prepared
	local _, _, _, _, isSet
	local s
	local a,b
	
	function frame:CheckTalents()
		prepared = true
		for a = 1,6 do
			for b = 0,2 do
				_, _, _, _, isSet = GetTalentInfo((a-1)*3+b+1)
				s = tonumber(string.sub(card["Talents"],a,a));
				
				frame.Talents[(a-1)*3+b+1].texture:SetDesaturated(1);
				frame.Talents[(a-1)*3+b+1]:SetHeight(24)
				frame.Talents[(a-1)*3+b+1]:SetWidth(24)
				
				if b == s then
					frame.Talents[(a-1)*3+b+1].texture:SetDesaturated(0);
					frame.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,0.2,0.2,1);
					frame.Talents[(a-1)*3+b+1]:SetHeight(32)
					frame.Talents[(a-1)*3+b+1]:SetWidth(32)
				end
				
				if isSet then --and s < 3 and b~=s then
					frame.Talents[(a-1)*3+b+1].texture:SetDesaturated(0);
					frame.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,1,1,1);
					prepared = false
				end
				
			
			end
		end
		
		return prepared
	end
	
		
	frame.Glyph = {};
	
	for a=1,6 do
	--local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, frame, nil, "LEFT", frame, "RIGHT", -64+floor((a-1)/2)*64, -64*mod(a,2), 64-16*mod(a,2), 64-16*mod(a,2))
	local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, frame, nil, "CENTER", textbox, "BOTTOM", cos(a*60-30)*12*(5-mod(a,2))+50, sin(a*60-30)*12*(5-mod(a,2))-120, 48-8*mod(a,2), 48-8*mod(a,2))
		tmpframe:SetBackdrop({
				bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK"
			})
			
		tmpframe.icon = "Interface/ICONS/INV_MISC_QUESTIONMARK"
		--tmpframe:SetScript("OnMouseUp", function() if PlayerTalentFrame and PlayerTalentFrame:IsVisible() then PlayerTalentFrame_Close() else ToggleTalentFrame() OpenGlyphFrame() end end)
		tmpframe:SetScript("OnMouseUp", function() ToggleTalentFrame(); OpenGlyphFrame() end)
			
		function tmpframe:SetGlyph(icon, tmp)
			if icon then tmpframe:SetBackdrop({bgFile = icon}) tmpframe.icon = icon end
			
			if tmp then
				tmpframe:SetBackdropColor(1,1,1,1);
			else
				tmpframe:SetBackdropColor(1,0.2,0.2,1);
			end
		end
		
		
	frame.Glyph[a] = tmpframe;
	end

	
	local currentGlyphs = LBP:GetGlyphTable();  -- Glyphen die drin sind
	local copy = deepcopy(card["Glyphs"]); -- Glyphen die drin sein sollen	
	
	-- berprfen welche richtig sind
	for index,value in pairs(currentGlyphs) do
		frame.Glyph[index]:SetGlyph(value[2], true)
		frame.Glyph[index]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Glyph[index]); GameTooltip:SetGlyphByID(value[3]); GameTooltip:Show(); end)
		frame.Glyph[index]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				
		for icon, glyph_id in pairs(copy[tostring(value[1])]) do
			if value[2] == icon then
				currentGlyphs[index] = nil;
				copy[tostring(value[1])][icon] = nil;
				break
			end
		end		
	end
		
	for index,value in pairs (currentGlyphs) do
		for icon, glyph_id in pairs(copy[tostring(value[1])]) do
			frame.Glyph[index]:SetGlyph(icon, false)
			frame.Glyph[index]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Glyph[index]); GameTooltip:SetGlyphByID(glyph_id); GameTooltip:Show(); end)
			frame.Glyph[index]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
			copy[tostring(value[1])][glyph_id] = {};
			break
		end
	end
		


	
	
	
		local index,value,icon, glyph_id


	local a
	
	function frame:CheckGlyphs()
		prepared = true;

		current_glyphs = LBP:GetGlyphTable();

		for a = 1,6 do
			if frame.Glyph[a].icon == currentGlyphs[a][2] then			
				frame.Glyph[a]:SetGlyph(nil, true)
			else
				frame.Glyph[a]:SetGlyph(nil, false)
				prepared = false
			end
		end

		return prepared
	end
	


		if not card["Macro1"] then card["Macro1"] = "/script print(\"LBP: Macro #1\")"; end
		if not card["Macro2"] then card["Macro2"] = "/script print(\"LBP: Macro #2\")"; end
		if not card["Macro3"] then card["Macro3"] = "/script print(\"LBP: Macro #3\")"; end
		if not card["Macro4"] then card["Macro4"] = "/script print(\"LBP: Macro #4\")"; end


		if card["active"] then
			EditMacro(GetMacroIndexByName("LBP Macro 1"),"LBP Macro 1",nil, card["Macro1"])
			EditMacro(GetMacroIndexByName("LBP Macro 2"),"LBP Macro 2",nil, card["Macro2"])
			EditMacro(GetMacroIndexByName("LBP Macro 3"),"LBP Macro 3",nil, card["Macro3"])
			EditMacro(GetMacroIndexByName("LBP Macro 4"),"LBP Macro 4",nil, card["Macro4"])
		end
		








	
		local macro_iconTexture
			
	
	local macroframe1 = LBP:CreateFrame("frame", "Macroframe1", frame, nil, "CENTER", textbox, "BOTTOM", -24-4-48-8, -250, 48, 48);
		_, macro_iconTexture = GetMacroInfo("LBP Macro 1");
		macroframe1:SetBackdrop({bgFile = macro_iconTexture });
		macroframe1.bgFile = macro_iconTexture;
		macroframe1:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(macroframe1); GameTooltip:SetText(card["Macro1"]); GameTooltip:Show(); end)
		macroframe1:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
		
	local macroframe2 = LBP:CreateFrame("frame", "Macroframe2", frame, nil, "CENTER", textbox, "BOTTOM", -24-4, -250, 48, 48);
		_, macro_iconTexture = GetMacroInfo("LBP Macro 2");
		macroframe2:SetBackdrop({bgFile = macro_iconTexture });
		macroframe2.bgFile = macro_iconTexture;
		macroframe2:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(macroframe2); GameTooltip:SetText(card["Macro2"]); GameTooltip:Show(); end)
		macroframe2:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
		
	local macroframe3 = LBP:CreateFrame("frame", "Macroframe3", frame, nil, "CENTER", textbox, "BOTTOM", 24+4, -250, 48, 48);
		_, macro_iconTexture = GetMacroInfo("LBP Macro 3");
		macroframe3:SetBackdrop({bgFile = macro_iconTexture });
		macroframe3.bgFile = macro_iconTexture;
		macroframe3:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(macroframe3); GameTooltip:SetText(card["Macro3"]); GameTooltip:Show(); end)
		macroframe3:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
		
	local macroframe4 = LBP:CreateFrame("frame", "Macroframe4", frame, nil, "CENTER", textbox, "BOTTOM", 24+4+48+8, -250, 48, 48);
		_, macro_iconTexture = GetMacroInfo("LBP Macro 4");
		macroframe4:SetBackdrop({bgFile = macro_iconTexture });
		macroframe4.bgFile = macro_iconTexture;
		macroframe4:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(macroframe4); GameTooltip:SetText(card["Macro4"]); GameTooltip:Show(); end)
		macroframe4:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)	

		
		if not card["active"] then
			macroframe1:SetBackdrop({bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK" });
			macroframe1.bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK"
			macroframe2:SetBackdrop({bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK" });
			macroframe2.bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK"
			macroframe3:SetBackdrop({bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK" });
			macroframe3.bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK"
			macroframe4:SetBackdrop({bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK" });
			macroframe4.bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK"
		end		
		
		
	frame.button = CreateFrame("BUTTON", "OkayNTC", frame, "UIPanelButtonTemplate")
		frame.button:SetText("Edit")
		frame.button:SetWidth(180)
		frame.button:SetHeight(30)
		frame.button:SetScript("OnClick", 
			function(self) 
				LBPConfigframe:SetTemplate(zone, subzone, id)
				LBPConfigframe:Show()
				LBPConfigframe:Build()
				parent:Hide()
			end)
		frame.button:SetPoint('TOP', textbox, 'BOTTOM', 0, -300)

	if n>1 then

	frame:SetScript("OnMouseUp", 
			function(self) 
				for index,value in pairs(LBP_DB[zone][subzone]) do
					value["active"] = false
				end
				LBP_DB[zone][subzone][id]["active"] = true;
				
				for index,value in pairs(parent.cards) do
					value.timeUpdated = 0;
				end
				
				EditMacro(GetMacroIndexByName("LBP Macro 1"),"LBP Macro 1",nil, card["Macro1"])
				EditMacro(GetMacroIndexByName("LBP Macro 2"),"LBP Macro 2",nil, card["Macro2"])
				EditMacro(GetMacroIndexByName("LBP Macro 3"),"LBP Macro 3",nil, card["Macro3"])
				EditMacro(GetMacroIndexByName("LBP Macro 4"),"LBP Macro 4",nil, card["Macro4"])
				--frame.timeUpdated = 0;
			end)
	

	end
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

	local darkframe = LBP:CreateFrame("frame", "Darkframe", frame, nil, "CENTER", frame, "CENTER", 0, 0, 300, 450)
		darkframe:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark"});
		darkframe:SetBackdropColor(1, 1, 1 , .5)
		darkframe:SetFrameLevel(100)
		darkframe:Hide()

	-- OnUpdate Variablen


	local specid, spec, description, icon, background, role		
	local prepared = true;
	
	
	
	
	local spell_icon
	local tmp
		
local OnUpdate = function(elapsed)										-- Beginn OnUpdate	
	--print(id .." "..TimeSinceLastUpdate)
	
	if time()-frame.timeUpdated > -1 then --- UpdateFrequency then
	
	--print("jo")
	
		if not InCombatLockdown() and subzone ~= "" then
		
		

		specid, spec, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
			
		

		--card = deepcopy(LBP_DB[zone][subzone][id]);
		
		
		if n == 1 then LBP_DB[zone][subzone][id]["active"] = true end
		
		if n>1 and not LBP_DB[zone][subzone][id]["active"] then
			frame:SetScale(0.8)
		else 
			frame:SetScale(1)
		end
				
		textbox:SetText(card["Name"].."\n");
		--print (GetSubZoneText());
		s = LBP:GetTalentString();

		

		if card["Spec"] == spec then
			textbox:SetText(textbox:GetText().."Spec: " .."|cff00FF00"..card["Spec"].."|r".."\n");
		else
			textbox:SetText(textbox:GetText().."Spec: " .."|cffFF0000"..card["Spec"].."|r".."\n");
			prepared = false;
		end
		--print("Spec: "..name);
		
		if not frame:CheckTalents() then
			prepared = false;
		end

		if not frame:CheckGlyphs() then
			prepared = false;
		end


	
	

		--for index,value in pairs(LBP_DB[subzone]["Glyphs"]) do
--			LBPMainframe:SetText(LBPMainframe:GetText()..LBP_DB[subzone]["Glyphs"][index].." "..index.."\n");
		--end




		

		
	

			

		
		
		if LBP_DB[zone][subzone][id]["active"] then
			darkframe:Hide()

			
					_, macro_iconTexture = GetMacroInfo("LBP Macro 1");
			

		if macro_iconTexture ~= macroframe1.bgFile then
			macroframe1:SetBackdrop({bgFile = macro_iconTexture });
			macroframe1.bgFile = macro_iconTexture;
		end
			
		_, macro_iconTexture = GetMacroInfo("LBP Macro 2");
		if macro_iconTexture ~= macroframe2.bgFile then
			macroframe2:SetBackdrop({bgFile = macro_iconTexture });
			macroframe2.bgFile = macro_iconTexture;
		end
		
		_, macro_iconTexture = GetMacroInfo("LBP Macro 3");
		if macro_iconTexture ~= macroframe3.bgFile then
			macroframe3:SetBackdrop({bgFile = macro_iconTexture });
			macroframe3.bgFile = macro_iconTexture;
		end
		
		_, macro_iconTexture = GetMacroInfo("LBP Macro 4");
		if macro_iconTexture ~= macroframe4.bgFile then
			macroframe4:SetBackdrop({bgFile = macro_iconTexture });	
			macroframe4.bgFile = macro_iconTexture;	
		end


			else
			darkframe:Show()
		end
		
		if prepared then
			frame:SetBackdropColor(0, .3, 0 , 1)
		else
			frame:SetBackdropColor(0, 0, 0 , 1)
		end


	


	
	--print(GetTime().." OnUpdate")

	end
    frame.timeUpdated = time();
		

  end

end	

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	frame:SetScript("OnUpdate", function(self, event, ... ) OnUpdate(event, ...) end)
	
	

	
	local oldShow = frame.Show;
	
	frame.Show = function(...)
		TimeSinceLastUpdate = UpdateFrequency;
		oldShow(...)
	end
	
	frame:Hide()
	return frame
end


function LBP.CreateWindow(self)
	local frame = LBP:CreateFrame("frame", "LBPMainFrame", UIParent, nil, "CENTER", UIParent, "CENTER", 0, 200, 300, 60)
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	--frame:Show()
	tinsert(UISpecialFrames,"LBPMainFrame");
	
	local textbox = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", frame, "TOP", 0, 0, 300, 50, "CENTER", "CENTER", 1, 1, 1, 1)
	
	local zone
	local subzone
	--if not frame.zone then frame.zone = GetZoneText() end
	--if not frame.subzone then frame.subzone = GetSubZoneText() end
	
	frame.cards ={}
	
	textbox:SetText("nhh")
	--textbox:Show()	
	
	function frame:SetText(msg)
		textbox:SetText(msg)
	end
	
	function frame:GetText()
		return textbox:GetText(msg)
	end
	
	
	

	
	
	frame.button = CreateFrame("BUTTON", "OkayNTC", frame, "UIPanelButtonTemplate")
		frame.button:SetText("X")
		frame.button:SetWidth(30)
		frame.button:SetHeight(30)
		
		frame.button:SetScript("OnClick", 
			function(self) 
				showmode = false;
				frame:Hide()
			end)
		frame.button:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, 0)
	

local OnUpdate = function(elapsed)										-- Beginn OnUpdate
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed; 	
	
	
	if (TimeSinceLastUpdate > UpdateFrequency) then
		local zonetext = GetZoneText();
		local subzonetext = GetSubZoneText();
		if not InCombatLockdown() and subzonetext ~= "" then
			
			
			if frame.zone ~= zonetext or frame.subzone ~= subzonetext then
				frame.zone = zonetext
				frame.subzone = subzonetext
				
				frame:SetText(frame.zone .."\n".. frame.subzone)

				local n = 0;
				if LBP_DB[zonetext] then
					if LBP_DB[zonetext][subzonetext] then
						for index,value in pairs(LBP_DB[zonetext][subzonetext]) do	
							n = n+1;
						end
					end
				end				
				
				for index,value in pairs(frame.cards) do
					value:Hide()
				end
				
				frame.cards = nil;
				frame.cards = {};

				if n>0 then
					a = 1;
					for index,value in pairs(LBP_DB[zonetext][subzonetext]) do
						local tmpframe = LBP:CreateCard( frame, frame.zone, frame.subzone, index, n)
						
						tmpframe:SetPoint("TOP", frame, "BOTTOM", a*300-150-n*150, 0)

						tmpframe:Show()
						--local tmpframe = LBP:CreateFrame("frame", "Card", frame, nil, "TOP", frame, "BOTTOM", a*300-300, 0, 300, 150)
						--tmpframe:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });

						--tmpframe.textbox = LBP:CreateFontString(tmpframe, "textbox", "ARTWORK", "GameFontNormalLarge", "TOP", tmpframe, "TOP", 0, 0, 300, 50, "CENTER", "CENTER", 1, 1, 1, 1)
						--tmpframe.textbox:SetText(index)
						
						frame.cards[a] = tmpframe;
					
						a = a+1;
					end
				else
					if LBP_DB[zonetext] then
						LBP_DB[zonetext][subzonetext] = nil
					end
					frame:Hide()
				end
			end
			

		
			
			TimeSinceLastUpdate = 0;
		else
			
			frame:Hide()
		end
	end
	
end	

	
	
	
	frame:SetScript("OnUpdate", function(self, event, ... ) OnUpdate(event, ...) end)
	
	local oldShow = frame.Show;
	
	frame.Show = function(...)
		TimeSinceLastUpdate = UpdateFrequency;
		oldShow(...)
	end
	
	frame:Hide()
	return frame
end


function LBP.GetTalentString(self)
	s = "";
	for b = 0,5 do
		for a = 1,3 do
			local name, iconTexture, tier, column, rank, maxRank, isExceptional, meetsPrereq, previewRank, meetsPreviewPrereq = GetTalentInfo(b*3+a)
			if rank then s = s..a-1; end
			
	
		end
	end
	return s
end



local glyphType, icon
local icon2, castSpell
local a,b
local s = {};

function LBP.GetGlyphTable(self)
	for b = 1,6 do
		if not s[b] then s[b] = {} end
		_, glyphType, _, _, icon = GetGlyphSocketInfo(b)
		
		for a=1,GetNumGlyphs() do 
			_, _, _, icon2, castSpell = GetGlyphInfo(a)
			if icon2 == icon then 
				s[b][1] = glyphType
				s[b][2] = icon
				s[b][3] = castSpell
				break 
			end
		end
	end
	return s
end





function LBP.OnEvent( self, event, name, ...)
	if event=="UPDATE_MACROS" then
		if not InCombatLockdown() then
			local numglobal,numperchar = GetNumMacros();
			
			if numglobal > 32 then
				LBP:echo("Not enough space to create the macros. LBP needs four free macro slots")
				EventFrame:UnregisterAllEvents();
			else
				if not GetMacroInfo("LBP Macro 1") then
					CreateMacro("LBP Macro 1", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #1\")", nil);
				end
				if not GetMacroInfo("LBP Macro 2") then
					CreateMacro("LBP Macro 2", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #2\")", nil);
				end
				if not GetMacroInfo("LBP Macro 3") then
					CreateMacro("LBP Macro 3", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #3\")", nil);
				end
				if not GetMacroInfo("LBP Macro 4") then
					CreateMacro("LBP Macro 4", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #4\")", nil);
				end
			end
		end
	end
	if event=="VARIABLES_LOADED" then
		EventFrame:UnregisterEvent("ADDON_LOADED");
		
		
		
		
		
			
		

		
		
		
		
		
		
		
		
		
		
		EventFrame:SetScript("OnUpdate", 
			function(self, event, ... ) 
				local _, iconTexture = GetTalentInfo(18) 
				if iconTexture then 
					LBPMainframe = LBP:CreateWindow();
					LBPConfigframe = LBP:CreateConfig(); 
					
					LBPMainframe:Hide()
					LBPConfigframe:Show()
					
					
					
					
					
	-- neue struktur, diese umwandlung fliegt in ein paar versionen raus				
		for zone in pairs (LBP_DB) do
			for subzone in pairs (LBP_DB[zone]) do
				for id in pairs (LBP_DB[zone][subzone]) do
					if not LBP_DB[zone][subzone][id]["Glyphs"]["1"] then
					
						local bla = {};
						bla["1"] = {};
						bla["2"] = {};
					
					
						for index in pairs (LBP_DB[zone][subzone][id]["Glyphs"]) do

							local name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(index)
							
							if icon then
							
							
								local glyphid = 0;
								for a=1,GetNumGlyphs() do 
									local name, glyphType, isKnown, icon2, castSpell,link, subText = GetGlyphInfo(a)
								
									
									if icon2 == icon then glyphid = castSpell break end
								
								end

								bla[tostring(LBP_DB[zone][subzone][id]["Glyphs"][index])][icon] = glyphid;
								
								LBP_DB[zone][subzone][id]["Glyphs"][index] = nil
							end
						end
						LBP_DB[zone][subzone][id]["Glyphs"] = bla
					
					end
				end
			end
		end					
					
					
					
					
					
					
					
					
					
					
					
					
					EventFrame:SetScript("OnUpdate", nil)
				end 
			end
		)
		
	
		-- Macros

		
--		LBPOnUpdateframe = LBP:CreateFrame("frame", "LBPOnUpdateFrame", UIParent, nil, "TOPLEFT", UIParent, "TOPLEFT", 0, 0, 10, 10)
		--LBPOnUpdateframe:SetScript("OnUpdate", function(self, event, ... ) LBP:OnUpdate(event, ...) end)
	
	end
	if event=="READY_CHECK" then
		--print("Tada")	
	end
	if not InCombatLockdown() and LBPMainframe and not LBPConfigframe:IsVisible() then
		--LBPMainframe.zone = GetZoneText();
		--LBPMainframe.subzone = GetSubZoneText();
	
		LBPMainframe:Show()	
	end
end											

function LBP.OnUpdate(self, elapsed)										-- Beginn OnUpdate
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed; 	

	while (TimeSinceLastUpdate > UpdateFrequency) do
	local zone = GetZoneText();
	local subzone = GetSubZoneText();
	
	if not LBP_DB[zone] then
		LBP_DB[zone] = {}
	end
  
	if GetSubZoneText() ~= "" and not LBP_DB[zone][subzone] then
		LBPOnUpdateframe:Hide()
	end
	if not InCombatLockdown() and GetSubZoneText() ~= "" then
		if LBP:Testing() then
			LBPMainframe:Hide()
			LBPOnUpdateframe:Hide()
		else
			LBPMainframe:Show()
		end
	end	
	if showmode then
		LBPOnUpdateframe:Show()
	end
	
	--print(GetTime().." OnUpdate")
			
    TimeSinceLastUpdate = TimeSinceLastUpdate - UpdateFrequency;
  end

end		

																-- Ende CreateFrame


function LBP.initialize(self)													-- Beginn initialize

	SlashCmdList["LBP"] = function( ) LBPMainframe:Hide() LBPConfigframe:Show() end
	SLASH_LBP1 = "/LBP";
	SLASH_LBP1 = "/lbp";
	
	EventFrame = CreateFrame( "Frame", "LBPEventframe", UIPARENT	)
	EventFrame:SetScript("OnEvent", function(self, event, ... ) LBP:OnEvent(event, ...) end)
	EventFrame:RegisterEvent("VARIABLES_LOADED");
	EventFrame:RegisterEvent("UPDATE_MACROS");
	EventFrame:RegisterEvent("ZONE_CHANGED");
	EventFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	EventFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
	EventFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	EventFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
	
	EventFrame:RegisterEvent("READY_CHECK");
	--LBPObject = LBPLayoutObj()
	
						
	
	LBP:echo("LBP initialized...")

end	

-- Ende initialize


-- Hilfsfunktionen zum Erstellen von Frames

function LBP.CreateFrame(self, frameType, name, parent, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height)
	local frame = CreateFrame(frameType, name, parent, template);
	frame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);
	frame:SetWidth(width);
	frame:SetHeight(height);
	
	return frame
end

function LBP.CreateFontString(self, frame, name, layer, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height, justifyH, justifyV, textColorR, textColorG, textColorB, textColorA)
	local fontstring = frame:CreateFontString(nil, layer, template)
		fontstring:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
		fontstring:SetWidth(width)
		fontstring:SetHeight(height)
		fontstring:SetJustifyH(justifyH)
		fontstring:SetJustifyV(justifyV)
		fontstring:SetTextColor( textColorR, textColorG, textColorB, textColorA );
	
	return fontstring
end

LBP.initialize()




